/*
Module : DTIME+Defines.H 
Purpose: Defines various enums and structs used by DTime+
Created: PJN / 01-05-2006
History: PJN / 29-05-2006 1. Removed the now unnecessary defines DTIMEPLUS_EXT_CLASS and DTIMEPLUS_EXT_API. 
                          These are no longer required because DTime+ is template based.

Copyright (c) 2006 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


/////////////////////////// Macros / Defines //////////////////////////////////

#ifndef __DTIMEPLUSDEFINES_H__
#define __DTIMEPLUSDEFINES_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


namespace DTimePlus
{

//////////////////////////// Enums / Structs //////////////////////////////////

enum Month
{ 
  January   = 1,
  February  = 2,
  March     = 3,
  April     = 4,
  May       = 5,
  June      = 6,
  July      = 7,
  August    = 8,
  September = 9,
  October   = 10,
  November  = 11,
  December  = 12
};

enum DayOfWeek 
{ 
  Sunday    = 1,
  Monday    = 2,
  Tuesday   = 3,
  Wednesday = 4,
  Thursday  = 5,
  Friday    = 6,
  Saturday  = 7
};

enum DateEpoch 
{ 
  EPOCH_JD    = 0,
  EPOCH_MJD   = 1,
  EPOCH_1900  = 2,
  EPOCH_1950  = 3,
  EPOCH_CTIME = 4,
  EPOCH_2000  = 5,
  EPOCH_GREG  = 6
};

struct DateS
{
  long      lYear;
  WORD      wMonth;
  WORD      wDay;
  DayOfWeek weekday;
  WORD      wYearday;
};

struct DateLS
{
  long      lYear;
  WORD      wMonth;
  WORD      wDay;
  DayOfWeek weekday;
  WORD      wYearday;
  WORD      wHour;
  WORD      wMinute;
  WORD      wSecond;
};

} //namespace DTimePlus

#endif //__DTIMEPLUSDEFINES_H__
