#include "stdafx.h"
#include "VFWGrab.h"
#include "MainFrame.h"
#include "FTPTransferDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CVFWGrabApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

CVFWGrabApp::CVFWGrabApp()
{
}

CVFWGrabApp theApp;

BOOL CVFWGrabApp::InitInstance()
{
  //Initialize GDI+
  Gdiplus::GdiplusStartupInput gdiplusStartupInput;
  if (Gdiplus::GdiplusStartup(&m_GDIplusToken, &gdiplusStartupInput, NULL) != Gdiplus::Ok)
  {
    AfxMessageBox(_T("Failed to initialize GDI+"));
    return FALSE;
  }

	//Parse command line for the filename of the ini file
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
  if (cmdInfo.m_strFileName.GetLength())
  {
    free(const_cast<void*>(reinterpret_cast<const void*>(m_pszProfileName)));
    m_pszProfileName = _tcsdup(cmdInfo.m_strFileName);
  }
  else
  {
    //Set the ini file to be the same name as the exe located where the exe is running from
    TCHAR szIni[_MAX_PATH];
    GetModuleFileName(NULL, szIni, _MAX_PATH);
    TCHAR szDrive[_MAX_DRIVE];
    TCHAR szDir[_MAX_DIR];
    TCHAR szFname[_MAX_FNAME];
    _tsplitpath_s(szIni, szDrive, sizeof(szDrive)/sizeof(TCHAR), szDir, sizeof(szDir)/sizeof(TCHAR), szFname, sizeof(szFname)/sizeof(TCHAR), NULL, 0);
    _tmakepath_s(szIni, sizeof(szIni)/sizeof(TCHAR), szDrive, szDir, szFname, _T("ini"));
    free(const_cast<void*>(reinterpret_cast<const void*>(m_pszProfileName)));
    m_pszProfileName = _tcsdup(szIni);
  }

  //Create the mainframe window which has the VFW capture window
  CMainFrame* pMainframe = new CMainFrame;
  if (!pMainframe->LoadFrame(IDR_MAINFRM))
    return FALSE;
  m_pMainWnd = pMainframe;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

int CVFWGrabApp::ExitInstance()
{
  //Close down GDI+
  Gdiplus::GdiplusShutdown(m_GDIplusToken);
  
  //Let the parent class do its thing
  return CWinApp::ExitInstance();
}